# -*- perl -*-


use strict;

package CHIRP::Lowercase;


my(%namelessdict_map) = (
	'oid' => 1,
	'rra' => 1,
	'html' => 1,
	'color' => 1,
	'range' => 1);

sub LowercaseConfig {
	my($config) = @_;

	foreach my $dict (keys % {$$config}) {
		if(!defined($namelessdict_map{lc($dict)})) {
			foreach my $name (keys % {$$config->{$dict}}) {
				next if ($name =~ /^--order--$/);
				foreach my $tag (keys % {$$config->{$dict}->{$name}}) {
					if($tag =~ /[A-Z]/) {
						$$config->{$dict}->{$name}->{lc($tag)} = $$config->{$dict}->{$name}->{$tag};
						delete $$config->{$dict}->{$name}->{$tag};
					}
				}
				if($name =~ /[A-Z]/) {
					$$config->{$dict}->{lc($name)} = $$config->{$dict}->{$name};
					delete $$config->{$dict}->{$name};
				}
			}
		} else {
			foreach my $tag (keys % {$$config->{$dict}}) {
				next if ($tag =~ /^--order--$/);
				if($tag =~ /[A-Z]/) {
					$$config->{$dict}->{lc($tag)} = $$config->{$dict}->{$tag};
					delete $$config->{$dict}->{$tag};
				}
			}
		}
		if($dict =~ /[A-Z]/) {
			$$config->{lc($dict)} = $$config->{$dict};
			delete $$config->{$dict};
		}
	}

	return $config;
}

1;
