# -*- perl -*-


use strict;

package SNMP;

use SNMP_Session;
use SNMP_util;


# this funky wrapper is because SNMP_Session throws exceptions with
# warn(), which we need to catch, instead of letting them run
# roughshod over Cricket's output.

sub _do {
	my($subref, @args) = @_;
	my(@res);

	eval {
		local($SIG{'__WARN__'}) = sub { die($_[0]); };
		@res = &{$subref}(@args);
	};

	return @res;
}

sub get {
	_do(\&snmpget, @_);
}

sub getnext {
	_do(\&snmpgetnext, @_);
}

sub walk {
	_do(\&snmpwalk, @_);
}

1;
